// listen content_script
chrome.extension.onRequest.addListener(function(request, sender, response) {
  if(request.name == "xl_download"){
		InvokeThunder(request.link, request.cookie, request.referurl);
	}
});

// menu click
function onStartupThunder(info, tab) {
	chrome.cookies.getAll({url:info.pageUrl}, function(cookies) {
		var cookie = "";
		for (i in cookies) {
			cookie = cookie.concat(cookies[i].name, "=", cookies[i].value, "; ");
		};
		InvokeThunder(info.linkUrl, cookie, info.pageUrl);
	});
}

// create menu
chrome.contextMenus.create({type:"normal", title:chrome.i18n.getMessage("context_title"), contexts:["link"], onclick:onStartupThunder});

// invoke thunder
function InvokeThunder(link, cookie, referurl) {
	var g_strSplitter = "#@$@#";
	var strUrls = referurl;
	strUrls = strUrls.concat(g_strSplitter);
	strUrls = strUrls.concat(1, g_strSplitter);
	
	strUrls = strUrls.concat(link, g_strSplitter);
	strUrls = strUrls.concat("", g_strSplitter);
	strUrls = strUrls.concat("", g_strSplitter);
	strUrls = strUrls.concat(cookie, g_strSplitter);
	strUrls = strUrls.concat("", g_strSplitter);
	strUrls = strUrls.concat("", g_strSplitter);
	var xl_plugin = document.getElementById('xl_chrome_plugin');
	
	return xl_plugin.DownLoadByThunder(strUrls);
}